// Code statistics:

// db: 6800 lines (Ontologent)

// rdf: 480 + 1720 = 2200, lms query: 120 + 1480 + 130 = 1730, total graph: 3900
// interfaces + MapPair: 1120
// graph + morphisms: 5020

// interpreter: 1170 + 890 = 2050
// 660 primitive ops + Merge (700) + Match w/ extras (1760)
// 145 forward, reverse, 80 reachable
// 1400: generic gui code
// total generic: 6800

// non-generic:
// sqlddl: 1280
// xml: 630
// xsd: 740
// sqlview: 1500
// converters: XSD2SQL: 260, SQL2XSD: 250, ExtractMapFromView: 90, ViewFromMap: 200
// total non-generic: 5000

// total: 24000 (interpreter, db, guis, rel/xsd/views)

// Database configuration

dbconfig("org.gjt.mm.mysql.Driver",
         "jdbc:mysql://localhost/rdfsql2",
         "melnik",
         "");

registerLanguage(com.interdataworking.gateway.sqlddl.LanguageCallbackSQL);
registerLanguage(com.interdataworking.gateway.sqlview.LanguageCallbackView);
registerLanguage(com.interdataworking.gateway.xml.LanguageCallbackXML);


// Syntax layer: XML to object graph
// ---------------------------------
alias SiRPAC org.w3c.rdf.implementation.syntax.sirpac.SiRPAC;
alias XMI2Obj com.interdataworking.gateway.XMI2Obj;
alias SQLDDL2Obj com.interdataworking.gateway.sqlddl.SQLDDL2Obj;
alias Insert2Obj com.interdataworking.gateway.sqlddl.Insert2Obj; // insert stmts
alias OEM2Obj com.interdataworking.gateway.oem.OEM2Obj;
alias SQLDDLWithMD2Obj com.interdataworking.gateway.sqlddl.SQLDDLWithMD2Obj;
alias XML2RDF com.interdataworking.gateway.xml.XML2RDF2; // child
alias XSD2Obj com.interdataworking.gateway.xml.XML2RDF2; // child
alias XML2Obj com.interdataworking.gateway.xml.XML2RDF;  // tag names as relations
// alias XML2Obj com.interdataworking.gateway.xml.XML2RDFNC;  // compact CDATA
alias SQLDDLObj2XSD com.interdataworking.gateway.sqlddl.Obj2XSD;  // writes DDL definitions as XSD
alias SQLDDL2XSD com.interdataworking.gateway.sqlddl.SQLDDL2XSD;  // 250 writes DDL definitions as XSD
alias XSD2SQLDDL com.interdataworking.gateway.sqlddl.XSD2SQLDDL;  // 260 writes XSD definitions as DDL
alias DependenciesXSD com.interdataworking.gateway.xml.DependenciesXSD;
alias CanonicalMapXSD com.interdataworking.gateway.xml.CanonicalMapXSD;

alias SQLView2Obj com.interdataworking.gateway.sqlview.SQLView2Obj;
alias Obj2SQLView com.interdataworking.gateway.sqlview.Obj2SQLView;
alias SQLViewText2Ref com.interdataworking.gateway.sqlview.Text2Ref;
alias ExtractMapFromSQLView com.interdataworking.gateway.sqlview.ExtractMap; // 90
alias GenerateSQLView com.interdataworking.gateway.sqlview.GenerateView; // 200
// TODO: ExtractMap: + tables; Generate: WHERE

alias Obj2Text com.interdataworking.gateway.Obj2Text;

// Syntax layer: serialize object graph
// ------------------------------------
alias SiRS org.w3c.rdf.implementation.syntax.sirpac.SiRS;
alias TripleSerializer edu.stanford.db.rdf.syntax.generic.TripleSerializer;
alias TripleParser edu.stanford.db.rdf.syntax.generic.TripleParser;
alias Obj2SQLDDL com.interdataworking.gateway.sqlddl.Obj2SQLDDL;
alias CanonicalMapSQL com.interdataworking.gateway.sqlddl.CanonicalMap;
// alias SelectSQL com.interdataworking.gateway.sqlddl.Select;
// alias DependenciesSQL com.interdataworking.gateway.sqlddl.Select;
// alias InvSelectSQL com.interdataworking.gateway.sqlddl.InvSelect;
alias ShuffleSQL com.interdataworking.gateway.sqlddl.ShufflerSQL;

// alias SelectMap com.interdataworking.mm.alg.SelectMap;
alias Obj2XML com.interdataworking.gateway.xml.RDF2XML;
alias RDF2XML com.interdataworking.gateway.xml.RDF2XML2;
alias Obj2XSD com.interdataworking.gateway.xml.RDF2XML2;
// alias MapToText com.interdataworking.mm.alg.MapToText;
alias MapGroupToText com.interdataworking.mm.alg.MapGroupToText;
alias MapToTextVerbose com.interdataworking.mm.alg.MapToText2;
alias MapToTextLiterals com.interdataworking.mm.alg.MapToText3;
// alias StringMapParser com.interdataworking.mm.EvaluateMapping;
alias TextToMap com.interdataworking.gateway.TextMapParser;
alias MapToText com.interdataworking.gateway.MapToText;
alias TextToSelector com.interdataworking.gateway.TextSelectorParser;
alias SelectorToText com.interdataworking.gateway.SelectorToText;

// Object layer
// ------------
alias OrderReification2RDF com.interdataworking.gateway.OrderReification2RDF;
alias OrderRDF2Reification com.interdataworking.gateway.OrderRDF2Reification;
alias IdentityUML2RDF com.interdataworking.gateway.IdentityUML2RDF;
alias Quad2Reification com.interdataworking.gateway.Quad2Reification;
alias Reification2Quad com.interdataworking.gateway.Reification2Quad;

// Semantic layer
// --------------
alias DAMLO2RDFS com.interdataworking.gateway.DAMLO2RDFS;
alias RDFS2DAMLO com.interdataworking.gateway.RDFS2DAMLO;
alias GeneralizationUML2RDFS com.interdataworking.gateway.GeneralizationUML2RDFS;
alias AssociationUML2RDFS com.interdataworking.gateway.AssociationUML2RDFS;
alias AttributeUML2RDFS com.interdataworking.gateway.AttributeUML2RDFS;
alias AttributeProtege2DAMLO com.interdataworking.gateway.AttributeProtege2DAMLO;
alias DAMLRestrictionMerger com.interdataworking.gateway.DAMLRestrictionMerger;

alias SQLDDLMapFilter com.interdataworking.mm.alg.SQLDDLMapFilter;
alias XMLMapFilter com.interdataworking.mm.alg.XMLMapFilter;
alias RDFSMapFilter com.interdataworking.mm.alg.RDFSMapFilter;
alias ResourceMapFilter com.interdataworking.mm.alg.ResourceMapFilter;


// Primitive operators
// -------------------

alias Invert com.interdataworking.mm.alg.Invert; // 50 TODO: replace IDs of MapEntries
alias Compose com.interdataworking.mm.alg.Compose; // 65
alias GraphMerge com.interdataworking.mm.alg.Merge; // 700
alias Union com.interdataworking.mm.alg.SetUnion; // 50
alias Subtract com.interdataworking.mm.alg.SetDifference; // 50
alias Intersect com.interdataworking.mm.alg.SetIntersection; // 50
alias Domain com.interdataworking.mm.alg.Domain; // 70
alias RestrictDomain com.interdataworking.mm.alg.RestrictDomain; // 65
alias TransitiveClosure com.interdataworking.mm.alg.TransitiveClosure; // 90
alias Subgraph com.interdataworking.mm.alg.Subgraph; // 70
alias Span com.interdataworking.mm.alg.Span; // 90
alias Submodel com.interdataworking.mm.alg.Submodel;
alias Id com.interdataworking.mm.alg.IdentityMap; // 50
alias Copy com.interdataworking.mm.alg.Copy; // 45 (m, selector) returns (m', m'_m)

// Algorithms, functions and gateways
// ----------------------------------

alias SFPjoin com.interdataworking.mm.alg.sfp.SFP;
alias Mjoin com.interdataworking.mm.alg.Match;
alias SFjoin com.interdataworking.mm.alg.Match; // 820
alias ExpandedMjoin com.interdataworking.mm.alg.ExpandedMatch;
alias MjoinSQL com.interdataworking.mm.alg.MatchSQL;

alias FilterBest com.interdataworking.mm.alg.FilterBest; // 170
alias NGramMatch com.interdataworking.mm.alg.NGramMatcher; // 770
alias StringMatch com.interdataworking.mm.alg.StringMatcher;
//alias StringMatch com.interdataworking.mm.alg.ExpandedStringMatcher;

alias Reverse com.interdataworking.mm.alg.Reverse; // 50
alias ReverseNonIdentical com.interdataworking.mm.alg.ReverseNonIdentical;
alias Forward com.interdataworking.mm.alg.Forward; // 50 map entries w/ forward direction
alias OneSimilarity com.interdataworking.mm.alg.OneSimilarity; // 45

alias All com.interdataworking.mm.alg.All;
alias Dependencies com.interdataworking.mm.alg.Dependencies;

alias IsEmpty com.interdataworking.mm.alg.IsEmpty; // 40

alias YesNo com.interdataworking.mm.gui.YesNo; // 40
alias AdjustMapping com.interdataworking.mm.gui.AdjustMapping; // 550 + 620 libraries
alias AdjustSelector com.interdataworking.mm.gui.AdjustSelector; // 200
alias ShowMap com.interdataworking.mm.gui.ShowMapping; // same as Adjust, but non-modal
alias ShowSelector com.interdataworking.mm.gui.ShowSelector; // same as Adjust, but non-modal

// Used in SF paper study
alias ReplaceIDs com.interdataworking.mm.alg.ReplaceIDs;


// Derived operators
// -----------------

  operator Range(map) {

    return Domain(Invert(map));
  }

  operator RestrictRange(map, selector) {

     return Invert(RestrictDomain(Invert(map), selector));
  }

  operator Restrict(map, m1, m2) {

     return RestrictRange(RestrictDomain(map, All(m1)), All(m2));
  }

  // returns set of nodes that are reachable from selector over directional links in map
  //
  operator Reachable(selector, map) {
      
     return Range(RestrictDomain(TransitiveClosure(map), selector));
  }

  operator SelectMin(M, selector, dep) {

     return Subgraph(M, selector + Reachable(selector, dep));
     // submodel instead of subgraph breaks DeleteHard (PK won't be deleted if referenced)
  }

  operator Select(M, selector) {

     T = Submodel(M, selector + Reachable(selector, Dependencies(M)));
     (M', M'_T) = Copy(T, All(T));
     return (M', M'_T);
     // to be used in additions
  }

  // default implementation called by Submodel
  operator Skeleton(M, s) {

     return Select(M, Span(M, s, All(M)), Dependencies(M));
  }

  operator Delete(M, selector) {

     return Select(M, All(M)-selector);
  }

  // deletes only those selected nodes that have no unselected dependent nodes
  //
  operator DeleteSoft(M, selector, dep) {

     cannotBeDeleted = Reachable(All(M) - selector, dep);
     toDelete = selector - cannotBeDeleted;
     toKeep = All(M) - toDelete;
     return Select(M, toKeep, dep);
  }

  // deletes all selected nodes and all dependent nodes
  // need to use Subgraph rather than Submodel!
  operator DeleteHard(M, selector, dep) {

     toDelete = selector + Reachable(selector, Invert(dep));
     toKeep = All(M) - toDelete;
     return Select(M, toKeep, dep);
  }

  // one-way difference (almost) as suggested by Phil
  //
  operator Diff(M1, map12) {

      M1' = DeleteSoft(M1, All(M1) - Domain(map12), Dependencies(M1));
      map12' = RestrictRange(map12, M1');
      return (M1', map12');
  }

  operator Project(selector, map) {

    return Range(RestrictDomain(map, selector));
  }

  operator Match(M1, M2, seedMap) {

      multimap = SFjoin(M1, M2, seedMap);
      multimap = RestrictDomain(multimap, All(M1));
      multimap = RestrictRange(multimap, All(M2));
      map = FilterBest(multimap);
      return (map, multimap);
  }

  operator ReplacementMap(map) {

      return Forward(map) + Reverse(Invert(map - Forward(map)));
  }

  operator Merge(M1, M2, M1_M2) {
      repl = ReplacementMap(M1_M2);
      repl = TransitiveClosure(repl);
      repl = RestrictRange(repl, Range(repl) - Domain(repl));
      G = GraphMerge(M1, M2, repl);
//      return M;
      M1_G = RestrictDomain(repl, All(M1)) + Id(All(M1) - Domain(repl));
      M2_G = RestrictDomain(repl, All(M2)) + Id(All(M2) - Domain(repl));

//	EditSelector(M1, M1_kept, "M1_kept");
//        EditMap(M1, G, M1_G, null, "M1_G");
//        EditMap(M2, G, M2_G, null, "M2_G");
      (M, M_G) = Copy(G, All(G));
      return (M, M1_G * Invert(M_G), M2_G * Invert(M_G));
  }

  operator Merge3(M1, M2, M3, repl) {
      repl = TransitiveClosure(repl);
      repl = RestrictRange(repl, Range(repl) - Domain(repl));
      M = GraphMerge(M1, M2, M3, repl);
      (M', M'_M) = Copy(M, All(M));

      M1_M' = Id(All(M1) - Domain(repl)) * Invert(M'_M);
      M2_M' = Id(All(M2) - Domain(repl)) * Invert(M'_M);
      M3_M' = Id(All(M2) - Domain(repl)) * Invert(M'_M);
      return (M', M1_M', M2_M', M3_M');
  }

/*
  operator Merge(M1, M2, M1_M2) {
      M = GraphMerge(M1, M2, M1_M2);
      (M', M'_M) = Copy(M, All(M));
      M1_kept = All(M1) - Domain(Forward(M1_M2));
      M2_kept = All(M2) - Range(M1_M2 - Forward(M1_M2));
      M1_M' = Id(M1_kept) * M_M';
      M2_M' = Id(M2_kept) * M_M';
//  	EditSelector(M1, M1_kept, "M1_kept");
//        EditMap(M1, M', M1_M', null, "M1_M'");
//  	EditSelector(M2, M2_kept, "M2_kept");
//        EditMap(M2, M', M2_M', null, "M2_M'");
      return (M', M1_M', M2_M');
  }
*/

  operator EditMap(M0, M1, M0_M1, multimap, winTitle) {

      return AdjustMapping(Obj2Text(M0), Obj2Text(M1), multimap, M0_M1, winTitle);
  }

  operator EditSelector(M0, selector, winTitle) {

      return AdjustSelector(Obj2Text(M0), selector, winTitle);
  }

  operator MatchEdit(M0, M1, seedMap, winTitle) {

      (M0_M1, multimap) = Match(M0, M1, seedMap);
      return EditMap(M0, M1, M0_M1, multimap, winTitle);
  }

  operator MatchSQLViews(view0, M01, M02, view1, M11, M12, seedMap, winTitle) {

      (view0_view1, multimap) = Match(view0, view1, seedMap);
      map = AdjustMapping(Obj2SQLView(view0 + M01 + M02),
                          Obj2SQLView(view1 + M11 + M12), multimap, view0_view1, winTitle);
      return map;
  }

  operator ReadSQLView(name, M1, M2) {

   read(view', SQLView2Obj, name);
   return SQLViewText2Ref(view', M1, M2);
  }

  operator showDependenciesView(view, M1, M2) {

      dependencies = Dependencies(view);
      (text, lines) = Obj2SQLView(view + M1 + M2);
      EditMap(text, lines, text, lines, dependencies, dependencies);
  }

// Native implementations of some derived operators
// ------------------------------------------------

alias Range com.interdataworking.mm.alg.Range;
alias RestrictRange com.interdataworking.mm.alg.RestrictRange;
alias Reachable com.interdataworking.mm.alg.Reachable; // 80
