package com.interdataworking.gateway;

import java.io.*;
import java.util.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import org.w3c.rdf.syntax.*;
import org.xml.sax.InputSource;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;

import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;

import com.interdataworking.mm.*;

public class TextSelectorParser implements RDFParser {

  public void parse(InputSource source, RDFConsumer consumer) throws SAXException {

    Reader r = source.getCharacterStream();
    if(r == null)
      r = new InputStreamReader(source.getByteStream());

    try {

      NodeFactory f = consumer.getNodeFactory();
      MapVocabulary M = new MapVocabulary(f);

      BufferedReader b = new BufferedReader(r);

      String line = null;

      while((line = b.readLine()) != null) {

	StringTokenizer st = new StringTokenizer(line, " \t\r");
	if(!st.hasMoreTokens())
	  continue;

	String src = st.nextToken();

	if(src.startsWith("//"))
	  continue;

	Resource e = createR(f, src);
	consumer.addStatement(f.createStatement(e, M.loop, e));
      }

    } catch (Exception me) {
      throw new SAXException(me);
    }
  }

  Resource createR(NodeFactory f, String s) throws ModelException {

    return RDFUtil.createGuessedResource(f, s);
  }

  public void setErrorHandler (ErrorHandler handler) {
    // do nothing
  }
}

