package com.interdataworking.gateway;

import java.util.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import com.interdataworking.*;
import com.interdataworking.util.*;
import edu.stanford.db.rdf.query.util.Skolem;

/**
 * Replaces every URI of type "var:" by a unique generated URI
 */

public class Var2Unique extends SimpleModelGateway {

  static final String prefix = "var:";

  Resource replaceVar(Resource r) throws ModelException {

    if(r.getURI().startsWith(prefix))
      return getUnique(new Skolem(r));
    else
      return r;
  }

  protected void processStatement(Statement st) throws ModelException {
    
    Resource s = replaceVar(st.subject());
    Resource p = replaceVar(st.predicate());
    RDFNode o = (st.object() instanceof Resource ? replaceVar((Resource)st.object()) : st.object());

    dest.remove(st);
    dest.add(stmt(s, p, o));
  }

}
