/* Generated By:JavaCC: Do not edit this line. SQLDDL.java */
package com.interdataworking.gateway.sqlddl;

import org.w3c.rdf.model.*;
import org.w3c.rdf.syntax.*;
import org.w3c.rdf.util.*;
//import org.w3c.rdf.implementation.query.*;
import org.w3c.rdf.implementation.model.*;
import edu.stanford.db.rdf.syntax.sirs.SiRS;
import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;
import org.w3c.rdf.vocabulary.dublin_core_19990702.DC;
import edu.stanford.db.rdf.vocabulary.order_20000527.RDFX;
import java.util.*;
import java.io.*;

public class SQLDDL implements SQLDDLConstants {

  static final boolean USE_UNIQUE = false;
  boolean INCLUDE_COL_DESC = false;

  NodeFactory factory;
  RDFConsumer consumer;

  Resource currentTableDef;
  String currentTableName;

  Map tableMap = new HashMap(); // maps strings to resources
  Map table2columns = new HashMap(); // maps table name to list of column names
  Map columnMap = new HashMap(); // maps strings (table, column) to resources
  int colNumWithinTable = 0;
  Map typeMap = new HashMap(); // global, maps strings to resources for a type definition (simple types only!)
  SQLDDLVocabulary R;

  String uniquePrefix;

  public void setIncludeColDesc(boolean b) {
    INCLUDE_COL_DESC = b;
  }


  String getFullColumnName(String tableName, String colName) {

    return tableName + "/" + colName;
  }

  String getFullColumnName(String colName) {

    return getFullColumnName(currentTableName, colName);
  }

  Resource getColumn(String tableName, String colName) throws ParseException {

    Resource col = (Resource)columnMap.get(getFullColumnName(tableName, colName));
    if(col == null)
      bailOut("Reference to undefined column");
    return col;
  }

  Resource getColumn(String colName) throws ParseException {

    Resource col = (Resource)columnMap.get(getFullColumnName(currentTableName, colName));
    if(col == null)
      bailOut("Reference to undefined column");
    return col;
  }

  void insertColumn(Resource row, Resource table, String tableName, List fields, String value) throws ModelException, ParseException {

    if(fields.size() == 0)
      bailOut("Too many values");

    String cname = (String)fields.remove(0);
    Resource col = getColumn(tableName, cname);
    if(col == null)
      bailOut("Undefined column: " + getFullColumnName(tableName, cname));

    Resource field = factory.createUniqueResource();
    add(row, R.hasField, field);
    add(field, RDF.type, col);
    add(field, RDF.value, literal(value));

//    add(row, col, literal(value));
  }


  void bailOut(String msg) throws ParseException {

    Token t = token;
    throw new ParseException("Error at line " + t.beginLine + ", column " + t.beginColumn + ": " + msg);
  }

  void log(String s) {

    System.out.println(s);
  }

  public void parseDDL(RDFConsumer consumer) throws ParseException, ModelException {

    this.consumer = consumer;
    this.factory = consumer.getNodeFactory();
    this.R = new SQLDDLVocabulary(factory);
    uniquePrefix = factory.createUniqueResource().getLabel() + "-";

    consumer.startModel();
    Input();
    consumer.endModel();
  }

  Statement add(Resource s, Resource p, RDFNode o) throws ModelException {

    Statement st = factory.createStatement(s, p, o);
    consumer.addStatement(st);
    return st;
  }

  Resource resource(String s) throws ModelException {

    return factory.createResource(s);
  }

  Literal literal(String s) throws ModelException {

    return factory.createLiteral(s);
  }

  Literal literal(int i) throws ModelException {

    return factory.createLiteral(i);
  }

  Resource resource(String ns, String s) throws ModelException {

    return factory.createResource(ns, s);
  }

  void addKeys(ArrayList list, Resource keyType, String name) throws ModelException, ParseException {

    Resource seq = factory.createUniqueResource();
    add(seq, RDF.type, keyType);
    if(name != null)
      add(seq, R.name, literal(name));
    add(currentTableDef, R.key, seq);

    for(int i=0; i < list.size(); i++) {

      String colName = (String)list.get(i);
      Resource colResource = getColumn(colName);
//      add(seq, factory.createOrdinal(i+1), colResource);
      Statement st = add(seq, R.keyColumn, colResource);
      add(st, RDFX.order, literal(i+1));
//      log("PK " + i + " is " + list.get(i));
    }
  }

  public static void main(String args[]) throws ParseException, ModelException, IOException {

    SQLDDL parser = args.length > 0 ?
        new SQLDDL(new StringReader(args[0])) :
        new SQLDDL(new InputStreamReader(System.in));
    Model m = new ModelImpl();
    RDFConsumer c = new ModelConsumer(m);
    parser.parseDDL(c);
    new SiRS().serialize(m, new OutputStreamWriter(System.out));
  }

  final public void Input() throws ParseException, ModelException {
        String s;
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CREATE:
      case COMMENT_LINE:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMENT_LINE:
          jj_consume_token(COMMENT_LINE);
          break;
        default:
          jj_la1[0] = jj_gen;
          ;
        }
        CreateTable();
        break;
      case INSERT:
        InsertStmt();
        break;
      default:
        jj_la1[1] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CREATE:
      case INSERT:
      case COMMENT_LINE:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_1;
      }
    }
    jj_consume_token(0);
  }

  final public void InsertStmt() throws ParseException, ModelException {
  List colNames = null;
  Token t;
  String s, tableName;
  Resource table;
    jj_consume_token(INSERT);
    jj_consume_token(INTO);
    t = jj_consume_token(IDENTIFIER);
    tableName = t.image;
    table = (Resource)tableMap.get(tableName);
    if(table == null)
      bailOut("Undefined table: " + tableName);
    Resource row = factory.createUniqueResource();
    add(row, R.rowOf, table);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      colNames = ColNameList();
      break;
    default:
      jj_la1[3] = jj_gen;
      ;
    }
    if(colNames == null) {
      // collect all column names
      colNames = new ArrayList((List)table2columns.get(tableName));
    }
    jj_consume_token(VALUES);
    jj_consume_token(LPAREN);
    s = LiteralValue();
    insertColumn(row, table, tableName, colNames, s);
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[4] = jj_gen;
        break label_2;
      }
      jj_consume_token(COMMA);
      s = LiteralValue();
    insertColumn(row, table, tableName, colNames, s);
    }
    if(colNames.size() > 0)
      bailOut("Value for column " + getFullColumnName(tableName, (String)colNames.get(0)) + " expected");
    jj_consume_token(RPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEMICOLON:
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[5] = jj_gen;
      ;
    }
  }

  final public void CreateTable() throws ParseException, ModelException {
  Token name;
  Resource col;
    jj_consume_token(CREATE);
    jj_consume_token(TABLE);
    name = jj_consume_token(IDENTIFIER);
//    log("Creating table " + name.image);
    currentTableName = name.image;
    currentTableDef = USE_UNIQUE ? factory.createUniqueResource() :
        factory.createResource(uniquePrefix, currentTableName);
    tableMap.put(currentTableName, currentTableDef);
    table2columns.put(currentTableName, new ArrayList());

    add(currentTableDef, RDF.type, R.TableDef);
    add(currentTableDef, R.name, literal(name.image));

    colNumWithinTable = 0;
    jj_consume_token(LPAREN);
    col = CreateDef();
    ColDesc(col);
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_3;
      }
      jj_consume_token(COMMA);
      ColDesc(col);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        col = CreateDef();
        break;
      case CHECK:
      case CONSTRAINT:
      case FOREIGN:
      case FULLTEXT:
      case INDEX:
      case KEY:
      case PRIMARY:
      case UNIQUE:
        Constraint();
        break;
      default:
        jj_la1[7] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      ColDesc(col);
    }
    jj_consume_token(RPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEMICOLON:
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
  }

  final public void ColDesc(Resource col) throws ParseException, ModelException {
  Token comment;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMENT_LINE:
      comment = jj_consume_token(COMMENT_LINE);
     String s = "";
     for(StringTokenizer st = new StringTokenizer(comment.image.substring(1), "\n\r\t "); st.hasMoreTokens();) {
       s += st.nextToken();
       if(st.hasMoreTokens())
         s += " ";
     }
     if(INCLUDE_COL_DESC)
       add(col, DC.Description, factory.createLiteral(s));
      break;
    default:
      jj_la1[9] = jj_gen;
      ;
    }
  }

  final public Resource CreateDef() throws ParseException, ModelException {
  String colName;
  String value;
  List foreignCols = null;
  Token foreignTable;
    colName = ColDef();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case _DEFAULT:
      jj_consume_token(_DEFAULT);
      value = Value();
     Resource col = getColumn(colName);
     add(col, R.defaultValue, literal(value));
      break;
    default:
      jj_la1[10] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NOT:
    case NULL:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NOT:
        jj_consume_token(NOT);
     Resource col = getColumn(colName);
     add(col, R.constraint, R.NotNull);
        break;
      default:
        jj_la1[11] = jj_gen;
        ;
      }
      jj_consume_token(NULL);
      break;
    default:
      jj_la1[12] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PRIMARY:
      jj_consume_token(PRIMARY);
      jj_consume_token(KEY);
      ArrayList list = new ArrayList();
      list.add(colName);
      addKeys(list, R.PrimaryKey, null);
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REFERENCES:
      jj_consume_token(REFERENCES);
      foreignTable = jj_consume_token(IDENTIFIER);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        foreignCols = ColNameList();
        break;
      default:
        jj_la1[14] = jj_gen;
        ;
      }
    Resource colDef = getColumn(colName);

    // create a ReferentialConstraint
    Resource ref = factory.createUniqueResource();
    add(currentTableDef, R.referentialConstraint, ref);

    String thatColName;
    if(foreignCols == null)
      thatColName = colName; // assume same name
    else
      thatColName = (String)foreignCols.get(0);

    // obtain the resource that corresponds to thatCol
    if(USE_UNIQUE)
      bailOut("Cannot parse foreign key references when USE_UNIQUE is switched on");

    Resource thatCol = factory.createResource(uniquePrefix, foreignTable.image + "/" + thatColName);

    add(ref, RDF.type, R.ReferentialConstraint);
    add(ref, R.foreignKeyRole, colDef);
    add(ref, R.uniqueKeyRole, thatCol);
      break;
    default:
      jj_la1[15] = jj_gen;
      ;
    }
    {if (true) return getColumn(colName);}
    throw new Error("Missing return statement in function");
  }

  final public void Constraint() throws ParseException, ModelException {
  ArrayList list;
  Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PRIMARY:
      jj_consume_token(PRIMARY);
      jj_consume_token(KEY);
      list = ColNameList();
    addKeys(list, R.PrimaryKey, null);
      break;
    case KEY:
      jj_consume_token(KEY);
      t = jj_consume_token(IDENTIFIER);
      list = ColNameList();
    addKeys(list, R.Key, t.image);
      break;
    case INDEX:
      jj_consume_token(INDEX);
      jj_consume_token(IDENTIFIER);
      ColNameList();
      break;
    case UNIQUE:
      jj_consume_token(UNIQUE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INDEX:
        jj_consume_token(INDEX);
        break;
      default:
        jj_la1[16] = jj_gen;
        ;
      }
      t = jj_consume_token(IDENTIFIER);
      list = ColNameList();
    addKeys(list, R.UniqueKey, t.image);
      break;
    case FULLTEXT:
      jj_consume_token(FULLTEXT);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INDEX:
        jj_consume_token(INDEX);
        break;
      default:
        jj_la1[17] = jj_gen;
        ;
      }
      jj_consume_token(IDENTIFIER);
      ColNameList();
      break;
    case CONSTRAINT:
    case FOREIGN:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CONSTRAINT:
        jj_consume_token(CONSTRAINT);
        jj_consume_token(IDENTIFIER);
        break;
      default:
        jj_la1[18] = jj_gen;
        ;
      }
      jj_consume_token(FOREIGN);
      jj_consume_token(KEY);
      jj_consume_token(IDENTIFIER);
      ColNameList();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case REFERENCES:
        jj_consume_token(REFERENCES);
        jj_consume_token(IDENTIFIER);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LPAREN:
          ColNameList();
          break;
        default:
          jj_la1[19] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case MATCH:
          jj_consume_token(MATCH);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case FULL:
            jj_consume_token(FULL);
            break;
          case PARTIAL:
            jj_consume_token(PARTIAL);
            break;
          default:
            jj_la1[20] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        default:
          jj_la1[21] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ON:
          jj_consume_token(ON);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case DELETE:
            jj_consume_token(DELETE);
            break;
          case UPDATE:
            jj_consume_token(UPDATE);
            break;
          default:
            jj_la1[22] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          jj_consume_token(IDENTIFIER);
          break;
        default:
          jj_la1[23] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[24] = jj_gen;
        ;
      }
      break;
    case CHECK:
      jj_consume_token(CHECK);
      jj_consume_token(IDENTIFIER);
      break;
    default:
      jj_la1[25] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public ArrayList ColNameList() throws ParseException {
  ArrayList list;
    list = ValueList();
    {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  final public ArrayList ValueList() throws ParseException {
  ArrayList list;
  String v;
    jj_consume_token(LPAREN);
    v = Value();
    list = new ArrayList();
    list.add(v);
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[26] = jj_gen;
        break label_4;
      }
      jj_consume_token(COMMA);
      v = Value();
     list.add(v);
    }
    jj_consume_token(RPAREN);
    {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  final public String Value() throws ParseException {
  Token s;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING_LITERAL:
      s = jj_consume_token(STRING_LITERAL);
      break;
    case FLOATING_POINT_LITERAL:
      s = jj_consume_token(FLOATING_POINT_LITERAL);
      break;
    case IDENTIFIER:
      s = jj_consume_token(IDENTIFIER);
      break;
    default:
      jj_la1[27] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return s.image;}
    throw new Error("Missing return statement in function");
  }

  final public String LiteralValue() throws ParseException {
  Token s;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING_LITERAL:
      s = jj_consume_token(STRING_LITERAL);
     {if (true) return s.image.substring(1, s.image.length()-1);}
      break;
    case FLOATING_POINT_LITERAL:
      s = jj_consume_token(FLOATING_POINT_LITERAL);
     {if (true) return s.image;}
      break;
    default:
      jj_la1[28] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public String ColDef() throws ParseException, ModelException {
  Token name,t;
  ArrayList list = null;
  Resource colDef = null;
  String colName, typeName;
    name = jj_consume_token(IDENTIFIER);
    t = jj_consume_token(IDENTIFIER);
    colName = name.image;
    typeName = t.image;
    colDef = USE_UNIQUE ? factory.createUniqueResource() :
        factory.createResource(uniquePrefix, currentTableName + "/" + colName);

    columnMap.put(getFullColumnName(colName), colDef);
    List l = (List)table2columns.get(currentTableName);
    l.add(colName);

    Statement st = add(currentTableDef, R.column, colDef);
    // preserve order of columns
    add(st, RDFX.order, literal(++colNumWithinTable));

    add(colDef, RDF.type, R.ColDef);
    add(colDef, R.name, literal(colName));

//    log("IMAGE: " + image);

    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      list = ValueList();
      break;
    default:
      jj_la1[29] = jj_gen;
      ;
    }
    // try to reuse colType

    Resource colType = list == null ? (Resource)typeMap.get(typeName) : null;

    if(colType == null) {
      colType = factory.createUniqueResource();
      add(colType, RDF.type, R.TypeDef);
      add(colType, R.name /*RDF.value*/, literal(typeName));
      if(list == null) // remember only simple types
        typeMap.put(typeName, colType);
    }
    add(colDef, R.type, colType);

    if(list != null) { // complex type

      for(int i=0; i < list.size(); i++) {

        String value = (String)list.get(i);
        st = add(colType, R.param, literal(value));
        add(st, RDFX.order, literal(i+1));
      }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case UNSIGNED:
      jj_consume_token(UNSIGNED);
      break;
    default:
      jj_la1[30] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ZEROFILL:
      jj_consume_token(ZEROFILL);
      break;
    default:
      jj_la1[31] = jj_gen;
      ;
    }
    {if (true) return colName;}
    throw new Error("Missing return statement in function");
  }

  public SQLDDLTokenManager token_source;
  ASCII_UCodeESC_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[32];
  final private int[] jj_la1_0 = {0x0,0x20000200,0x20000200,0x0,0x0,0x0,0x0,0x241d180,0x0,0x0,0x400,0x40000,0xc0000,0x400000,0x0,0x800000,0x8000,0x8000,0x100,0x0,0x202000,0x20000,0x8000800,0x100000,0x800000,0x241d180,0x0,0x0,0x0,0x0,0x4000000,0x10000000,};
  final private int[] jj_la1_1 = {0x8,0x8,0x8,0x80,0x4000,0x2000,0x4000,0x10,0x2000,0x8,0x0,0x0,0x0,0x0,0x80,0x0,0x0,0x0,0x0,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x4000,0x15,0x5,0x80,0x0,0x0,};

  public SQLDDL(java.io.InputStream stream) {
    jj_input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source = new SQLDDLTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 32; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 32; i++) jj_la1[i] = -1;
  }

  public SQLDDL(java.io.Reader stream) {
    jj_input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source = new SQLDDLTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 32; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 32; i++) jj_la1[i] = -1;
  }

  public SQLDDL(SQLDDLTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 32; i++) jj_la1[i] = -1;
  }

  public void ReInit(SQLDDLTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 32; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[48];
    for (int i = 0; i < 48; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 32; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 48; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
