package com.interdataworking.gateway.sqlddl;

import java.util.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.implementation.model.*;

public class SQLDDLVocabulary {

  static final String NS = "http://www.interdataworking.com/vocabulary/sqlddl/1.0#";

  public Resource
    TableDef, ColDef, type, name, column,
    uniqueKey, key, foreignKey, UniqueKey, Key, param, TypeDef,
    defaultValue, constraint, NotNull, PrimaryKey, keyColumn,
    ReferentialConstraint, referentialConstraint, foreignKeyRole, uniqueKeyRole,
    rowOf, hasField;

  public Set ALL; // contains all vocabulary elements

  public static SQLDDLVocabulary create() {

    try {
      return new SQLDDLVocabulary(new NodeFactoryImpl());
    } catch (ModelException ex) {
      return null;
    }
  }

  public SQLDDLVocabulary(NodeFactory f) throws ModelException {
    
    ALL = new HashSet();
    TableDef = f.createResource(NS, "Table");
    ALL.add(TableDef);
    ColDef = f.createResource(NS, "Column");
    ALL.add(ColDef);
    TypeDef = f.createResource(NS, "ColumnType");
    ALL.add(TypeDef);
    name = f.createResource(NS, "name");
    ALL.add(name);
    type = f.createResource(NS, "sqlType");
    ALL.add(type);
    column = f.createResource(NS, "column");
    ALL.add(column);
    keyColumn = f.createResource(NS, "keyColumn");
    ALL.add(keyColumn);
    key = f.createResource(NS, "ownKey");
    ALL.add(key);
    foreignKey = f.createResource(NS, "foreignKey");
    ALL.add(foreignKey);
    PrimaryKey = f.createResource(NS, "PrimaryKey");
    ALL.add(PrimaryKey);
    UniqueKey = f.createResource(NS, "UniqueKey");
    ALL.add(UniqueKey);
    Key = f.createResource(NS, "Key");
    ALL.add(Key);
    param = f.createResource(NS, "param");
    ALL.add(param);
    defaultValue = f.createResource(NS, "default");
    ALL.add(defaultValue);
    constraint = f.createResource(NS, "constraint");
    ALL.add(constraint);
    NotNull = f.createResource(NS, "NotNull");
    ALL.add(NotNull);
    ReferentialConstraint = f.createResource(NS, "ReferentialConstraint");
    ALL.add(ReferentialConstraint);
    referentialConstraint = f.createResource(NS, "referentialConstraint");
    ALL.add(referentialConstraint);
    foreignKeyRole = f.createResource(NS, "foreignKeyRole");
    ALL.add(foreignKeyRole);
    uniqueKeyRole = f.createResource(NS, "uniqueKeyRole");
    ALL.add(uniqueKeyRole);
    rowOf = f.createResource(NS, "rowOf");
    ALL.add(rowOf);
    hasField = f.createResource(NS, "hasField");
    ALL.add(hasField);
  }
}
