package com.interdataworking.gateway.sqlddl;

import com.interdataworking.*;
import com.interdataworking.mm.*;
import com.interdataworking.mm.alg.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import java.util.*;
import edu.stanford.db.rdf.query.*;
import edu.stanford.db.rdf.query.memory.*;
//import edu.stanford.db.rdf.query.orderings.*;
import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;

import edu.stanford.db.rdf.util.Aggregator;

//public class Select extends GenericSelect {
public class Select extends GenericDependencies {

  //  Obj2SQLDDL os = new Obj2SQLDDL();
  SQLDDLVocabulary R = SQLDDLVocabulary.create();

  public Set getAggProp() {

    Set aggProp = new HashSet();

    aggProp.add(RDF.type); // need type for each node

    aggProp.add(R.type); // need SQL type for column
    aggProp.add(R.name); // need name for column
    aggProp.add(R.param); // need parameter for parameterized types
    aggProp.add(R.defaultValue); // need default value for column
    aggProp.add(R.constraint); // need constraint value for column
    aggProp.add(R.foreignKeyRole); // need both roles for referential constraint
    aggProp.add(R.uniqueKeyRole); // need both roles for referential constraint
    aggProp.add(R.keyColumn); // need all key columns for a key definition

    return aggProp;
  }

  public Set getInverseAggProp() {

    Set inverseAggProp = new HashSet();

    // weak: add target only, don't apply recursively on target

    //    weakAggProp.add(R.column); // need column for table, but table can exist w/o column
    //    weakAggProp.add(R.referentialConstraint); // table has but can exist w/o ref constraint

    inverseAggProp.add(R.column); // make sure table is there for a column

    // not needed, since field would be there, and transitively, table
    //    inverseAggProp.add(R.key); // need table for a key to make sense

    // make sure table is there for a ref constraint: not needed, since both roles/fields are there, transitive
    //    inverseAggProp.add(R.referentialConstraint);

    // don't do this. This requires that all sibling columns are dependent on this one
    //    inverseAggProp.add(R.keyColumn); // this column is (part of) key. Get the key info

    // inverseAggProp.add(R.foreignKeyRole); // this column is foreign key. Get the key and referenced column/table.
    // inverseAggProp.add(R.uniqueKeyRole); // column can exist w/o referential constraint

      // used for INSERT    rowOf, hasField;

    return inverseAggProp;
  }

}
