/* Generated By:JavaCC: Do not edit this line. SQLView.java */
package com.interdataworking.gateway.sqlview;

import org.w3c.rdf.model.*;
import org.w3c.rdf.syntax.*;
import org.w3c.rdf.util.*;
//import org.w3c.rdf.implementation.query.*;
import org.w3c.rdf.implementation.model.*;
import edu.stanford.db.rdf.syntax.sirs.SiRS;
import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;
import org.w3c.rdf.vocabulary.dublin_core_19990702.DC;
import edu.stanford.db.rdf.vocabulary.order_20000527.RDFX;
import java.util.*;
import java.io.*;
import org.xml.sax.*;
import edu.stanford.db.rdf.util.*;

public class SQLView implements SQLViewConstants {

  PowerModel m;

  void bailOut(String msg) throws ParseException {

    Token t = token;
    throw new ParseException("Error at line " + t.beginLine + ", column " + t.beginColumn + ": " + msg);
  }

  void resolve() throws ModelException {
  }

  void log(String s) {

    System.out.println(s);
  }

  public void parseSQL(Model m) throws ParseException, ModelException {

    this.m = PowerModel.create(m);
    Input();
    resolve();
  }

  public void parseSQL(RDFConsumer consumer) throws ParseException, ModelException {

    Model m = new RDFFactoryImpl().createModel();
    parseSQL(m);
    for(Enumeration en = m.elements(); en.hasMoreElements();)
      consumer.addStatement((Statement)en.nextElement());
  }

  void addDebugInfo(Resource r) throws ModelException {

    String str = "(row " + token.beginLine + ", column " + token.beginColumn + ")";
    m.add(r, SQLViewVocabulary.debugInfo, m.literal(str));
  }

  Resource createInlineTerm(String opName, Resource term1, Resource term2, List l) throws ModelException {

    if(term2 == null)
      return term1;
    return createInlineTerm(opName, l);
  }

  Resource createInlineTerm(String opName, List l) throws ModelException {

    Resource stmt = m.unique();
    m.add(stmt, RDF.type, SQLViewVocabulary.FunctionalTerm);
    m.add(stmt, SQLViewVocabulary.operatorName, opName);
    m.addOrdered(stmt, SQLViewVocabulary.term, l);
    return stmt;
  }

  public Resource conditionExpr(Resource whenTerm, Resource thenTerm) throws ModelException {

    Resource expr = m.unique();
    m.add(expr, RDF.type, SQLViewVocabulary.ConditionExpr);
    if(whenTerm != null)
      m.add(expr, SQLViewVocabulary.whenTerm, whenTerm);
    m.add(expr, SQLViewVocabulary.thenTerm, thenTerm);
    return expr;
  }

  public static void main(String args[]) throws Exception {

    RDFFactory rf = new RDFFactoryImpl();
    Model m = rf.createModel();

//    try {

      SQLView parser = args.length > 0 ?
        new SQLView(new StringReader(args[0])) :
        new SQLView(new InputStreamReader(System.in));

      RDFConsumer c = new ModelConsumer(m);
      parser.parseSQL(c);

//    } catch (SAXException ex) {
//      throw ex.getException() != null ? ex.getException() : ex;
//    }

    rf.createSerializer().serialize(m, new OutputStreamWriter(System.out));

//    RDFUtil.printStatements(ctx.getScriptModel(), System.out);
//    RDFUtil.dumpModel(ctx.getScriptModel(), System.out, rf.createSerializer());
  }

  final public void Input() throws ParseException, ModelException {
  Resource stmt = null;
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CREATE:
        CreateViewStmt();
        break;
      case SELECT:
        SelectStmt();
        break;
      default:
        jj_la1[0] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CREATE:
      case SELECT:
        ;
        break;
      default:
        jj_la1[1] = jj_gen;
        break label_1;
      }
    }
    jj_consume_token(0);
  }

  final public String Identifier() throws ParseException {
  Token t;
    t = jj_consume_token(IDENTIFIER);
    {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

  final public String TableName() throws ParseException {
  String s;
    s = Identifier();
    {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

  final public String FieldName() throws ParseException {
  String s;
    s = Identifier();
    {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

  final public Resource CreateViewStmt() throws ParseException, ModelException {
  Resource stmt = m.unique();
  String tableName, fieldName;
  List l = new ArrayList();
  Resource select;
    jj_consume_token(CREATE);
    jj_consume_token(VIEW);
                    addDebugInfo(stmt);
    tableName = TableName();
    jj_consume_token(LPAREN);
    fieldName = FieldName();
     l.add(fieldName);
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_2;
      }
      jj_consume_token(COMMA);
      fieldName = FieldName();
     l.add(fieldName);
    }
    jj_consume_token(RPAREN);
    jj_consume_token(AS);
    select = SelectStmt();
    m.add(stmt, RDF.type, SQLViewVocabulary.CreateView);
    Resource CVTable = m.unique();
    m.add(stmt, SQLViewVocabulary.cvTable, CVTable);
    m.add(CVTable, RDF.type, SQLViewVocabulary.CVTable);
    m.add(CVTable, SQLViewVocabulary.tableRef, tableName); // NEED RESOLVE

    for(int i=0; i < l.size(); i++) {
      Resource CVField = m.unique();
      m.add(stmt, SQLViewVocabulary.cvField, CVField, i+1);
      m.add(CVField, RDF.type, SQLViewVocabulary.CVField);
      m.add(CVField, SQLViewVocabulary.fieldRef, (String)l.get(i)); // NEED RESOLVE
    }

    m.add(stmt, SQLViewVocabulary.as, select);
    {if (true) return stmt;}
    throw new Error("Missing return statement in function");
  }

  final public List TermList() throws ParseException, ModelException {
  List l = new ArrayList();
  Resource t;
    t = Term();
    l.add(t);
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[3] = jj_gen;
        break label_3;
      }
      jj_consume_token(COMMA);
      t = Term();
                        l.add(t);
    }
    {if (true) return l;}
    throw new Error("Missing return statement in function");
  }

  final public Resource Term() throws ParseException, ModelException {
  Resource term = null;
    term = SumTerm();
   {if (true) return term;}
    throw new Error("Missing return statement in function");
  }

  final public Resource SumTerm() throws ParseException, ModelException {
  Resource term1 = null;
  Resource term2 = null;
  Token x;
    term1 = MultTerm();
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MINUS:
      case PLUS:
        ;
        break;
      default:
        jj_la1[4] = jj_gen;
        break label_4;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        x = jj_consume_token(PLUS);
        break;
      case MINUS:
        x = jj_consume_token(MINUS);
        break;
      default:
        jj_la1[5] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      term2 = MultTerm();
     List l = new ArrayList();
     l.add(term1);
     l.add(term2);
     term1 = createInlineTerm(x.image, l);
    }
    {if (true) return term1;}
    throw new Error("Missing return statement in function");
  }

  final public Resource MultTerm() throws ParseException, ModelException {
  Resource term1 = null;
  Resource term2 = null;
  Token x;
    term1 = ModuloTerm();
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TIMES:
      case SLASH:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_5;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TIMES:
        x = jj_consume_token(TIMES);
        break;
      case SLASH:
        x = jj_consume_token(SLASH);
        break;
      default:
        jj_la1[7] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      term2 = ModuloTerm();
     List l = new ArrayList();
     l.add(term1);
     l.add(term2);
     term1 = createInlineTerm(x.image, l);
    }
    {if (true) return term1;}
    throw new Error("Missing return statement in function");
  }

  final public Resource ModuloTerm() throws ParseException, ModelException {
  Resource term1 = null;
  Resource term2 = null;
  List l = new ArrayList();
    term1 = NegatedTerm();
                         l.add(term1);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MODULO:
      jj_consume_token(MODULO);
      term2 = NegatedTerm();
                                    l.add(term2);
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
    {if (true) return createInlineTerm("%", term1, term2, l);}
    throw new Error("Missing return statement in function");
  }

  final public Resource NegatedTerm() throws ParseException, ModelException {
  Resource term = null;
  Token x = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MINUS:
      x = jj_consume_token(MINUS);
      break;
    default:
      jj_la1[9] = jj_gen;
      ;
    }
    term = ParenTerm();
   if(x == null)
     {if (true) return term;}
   List l = new ArrayList();
   l.add(term);
   {if (true) return createInlineTerm("-", l);}
    throw new Error("Missing return statement in function");
  }

  final public Resource ParenTerm() throws ParseException, ModelException {
  Resource term = null;
    if (jj_2_1(2)) {
      jj_consume_token(LPAREN);
      term = Term();
      jj_consume_token(RPAREN);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
      case NULL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case LPAREN:
        term = ElementaryTerm();
        break;
      default:
        jj_la1[10] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
   {if (true) return term;}
    throw new Error("Missing return statement in function");
  }

  final public Resource ElementaryTerm() throws ParseException, ModelException {
  Resource term = null;
    if (jj_2_2(2)) {
      term = NestedSelectStmt();
    } else if (jj_2_3(2)) {
      term = FunctionalTerm();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        term = FieldTerm();
        break;
      case NULL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
        term = ConstantTerm();
        break;
      case CASE:
        term = CaseTerm();
        break;
      default:
        jj_la1[11] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
   {if (true) return term;}
    throw new Error("Missing return statement in function");
  }

  final public Resource CaseTerm() throws ParseException, ModelException {
  Resource headTerm = null;
  Resource whenTerm, thenTerm;
  Resource conditionExpr;
  List l = new ArrayList();
    jj_consume_token(CASE);
    headTerm = Term();
    label_6:
    while (true) {
      jj_consume_token(WHEN);
      whenTerm = Term();
      jj_consume_token(THEN);
      thenTerm = Term();
    l.add(conditionExpr(whenTerm, thenTerm));
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case WHEN:
        ;
        break;
      default:
        jj_la1[12] = jj_gen;
        break label_6;
      }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELSE:
      jj_consume_token(ELSE);
      thenTerm = Term();
                             l.add(conditionExpr(null, thenTerm));
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
    jj_consume_token(END);
   Resource stmt = m.unique();
   m.add(stmt, RDF.type, SQLViewVocabulary.CaseTerm);
   m.add(stmt, SQLViewVocabulary.headTerm, headTerm);
   m.addOrdered(stmt, SQLViewVocabulary.conditionExpr, l);
   {if (true) return stmt;}
    throw new Error("Missing return statement in function");
  }

  final public Resource Expression() throws ParseException, ModelException {
  Resource expr = null;
    expr = OrExpression();
   {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

  final public Resource OrExpression() throws ParseException, ModelException {
  Resource term1 = null;
  Resource term2 = null;
  List l = new ArrayList();
    term1 = AndExpression();
                           l.add(term1);
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OR:
        ;
        break;
      default:
        jj_la1[14] = jj_gen;
        break label_7;
      }
      jj_consume_token(OR);
      term2 = AndExpression();
                                 l.add(term2);
    }
    {if (true) return createInlineTerm("OR", term1, term2, l);}
    throw new Error("Missing return statement in function");
  }

  final public Resource AndExpression() throws ParseException, ModelException {
  Resource term1 = null;
  Resource term2 = null;
  List l = new ArrayList();
    term1 = NotExpression();
                           l.add(term1);
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AND:
        ;
        break;
      default:
        jj_la1[15] = jj_gen;
        break label_8;
      }
      jj_consume_token(AND);
      term2 = NotExpression();
                                  l.add(term2);
    }
    {if (true) return createInlineTerm("AND", term1, term2, l);}
    throw new Error("Missing return statement in function");
  }

  final public Resource NotExpression() throws ParseException, ModelException {
  Resource t = null;
  Token x = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NOT:
      x = jj_consume_token(NOT);
      break;
    default:
      jj_la1[16] = jj_gen;
      ;
    }
    t = ElementaryExpression();
   if(x == null)
     {if (true) return t;}
   Resource stmt = m.unique();
   m.add(stmt, RDF.type, SQLViewVocabulary.FunctionalTerm);
   m.add(stmt, SQLViewVocabulary.operatorName, "NOT");
   m.add(stmt, SQLViewVocabulary.term, t);
   {if (true) return stmt;}
    throw new Error("Missing return statement in function");
  }

  final public Resource ElementaryExpression() throws ParseException, ModelException {
  Resource t = null;
    if (jj_2_4(2147483647)) {
      t = InExpression();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
      case NULL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case LPAREN:
      case MINUS:
        t = EqualsExpression();
        break;
      default:
        jj_la1[17] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
   {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

  final public Resource EqualsExpression() throws ParseException, ModelException {
  Resource stmt = m.unique();
  Resource term1 = null;
  Resource term2 = null;
    term1 = Term();
    jj_consume_token(EQUALS);
    term2 = Term();
    m.add(stmt, RDF.type, SQLViewVocabulary.FunctionalTerm);
    m.add(stmt, SQLViewVocabulary.operatorName, "=");
    List l = new ArrayList();
    l.add(term1);
    l.add(term2);
    m.addOrdered(stmt, SQLViewVocabulary.term, l);
    {if (true) return stmt;}
    throw new Error("Missing return statement in function");
  }

  final public Resource InExpression() throws ParseException, ModelException {
  Resource stmt = m.unique();
  Resource t = null;
  List l = new ArrayList();
    t = Term();
              l.add(t);
    jj_consume_token(IN);
    if (jj_2_5(2)) {
      jj_consume_token(LPAREN);
      t = ConstantTerm();
                       l.add(t);
      label_9:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[18] = jj_gen;
          break label_9;
        }
        jj_consume_token(COMMA);
        t = ConstantTerm();
                                 l.add(t);
      }
      jj_consume_token(RPAREN);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        t = NestedSelectStmt();
                           l.add(t);
        break;
      default:
        jj_la1[19] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    m.add(stmt, RDF.type, SQLViewVocabulary.FunctionalTerm);
    m.add(stmt, SQLViewVocabulary.operatorName, "IN");
    m.addOrdered(stmt, SQLViewVocabulary.term, l);
    {if (true) return stmt;}
    throw new Error("Missing return statement in function");
  }

  final public Resource FieldTerm() throws ParseException, ModelException {
  Resource stmt = m.unique();
  String s = null;
  String fieldName, aliasName = null;
    addDebugInfo(stmt);
    s = Identifier();
    int i = s.indexOf('.');
    if(i > 0) {
      aliasName = s.substring(0, i);
      fieldName = s.substring(i+1);
    } else
      fieldName = s;

    m.add(stmt, RDF.type, SQLViewVocabulary.FieldTerm);
    m.add(stmt, SQLViewVocabulary.fieldRef, fieldName); // NEED RESOLVE
    if(aliasName != null)
      m.add(stmt, SQLViewVocabulary.aliasClause, aliasName); // NEED RESOLVE
    {if (true) return stmt;}
    throw new Error("Missing return statement in function");
  }

  final public Resource FunctionalTerm() throws ParseException, ModelException {
  Resource stmt = m.unique();
  String s = null;
  List l = null;
    addDebugInfo(stmt);
    s = Identifier();
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CASE:
    case NULL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case LPAREN:
    case MINUS:
      l = TermList();
      break;
    default:
      jj_la1[20] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    m.add(stmt, RDF.type, SQLViewVocabulary.FunctionalTerm);
    m.add(stmt, SQLViewVocabulary.operatorName, s);
    if(l != null)
      m.addOrdered(stmt, SQLViewVocabulary.term, l);
    {if (true) return stmt;}
    throw new Error("Missing return statement in function");
  }

  final public Resource ConstantTerm() throws ParseException, ModelException {
  Resource stmt = m.unique();
  Token s;
    addDebugInfo(stmt);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING_LITERAL:
      s = jj_consume_token(STRING_LITERAL);
      break;
    case FLOATING_POINT_LITERAL:
      s = jj_consume_token(FLOATING_POINT_LITERAL);
      break;
    case NULL:
      s = jj_consume_token(NULL);
      break;
    default:
      jj_la1[21] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
     m.add(stmt, RDF.type, SQLViewVocabulary.Constant);
     m.add(stmt, SQLViewVocabulary.constantValue, s.image);
     {if (true) return stmt;}
    throw new Error("Missing return statement in function");
  }

  final public Resource SelectStmt() throws ParseException, ModelException {
  Resource stmt = m.unique();
  List terms;
  Resource clause;
  List clauses = new ArrayList();
  Token x = null;
    addDebugInfo(stmt);
    jj_consume_token(SELECT);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DISTINCT:
      x = jj_consume_token(DISTINCT);
      break;
    default:
      jj_la1[22] = jj_gen;
      ;
    }
    terms = TermList();
    m.add(stmt, RDF.type, SQLViewVocabulary.Select);
    if(x != null)
      m.add(stmt, SQLViewVocabulary.selectModifier, "DISTINCT");
    m.addOrdered(stmt, SQLViewVocabulary.selectTerm, terms);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FROM:
      clause = FromClause();
    m.add(stmt, SQLViewVocabulary.fromClause, clause);
      break;
    default:
      jj_la1[23] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case WHERE:
      clause = WhereClause();
    m.add(stmt, SQLViewVocabulary.whereClause, clause);
      break;
    default:
      jj_la1[24] = jj_gen;
      ;
    }
    {if (true) return stmt;}
    throw new Error("Missing return statement in function");
  }

  final public Resource WhereClause() throws ParseException, ModelException {
  Resource stmt = m.unique();
  Resource term;
    addDebugInfo(stmt);
    jj_consume_token(WHERE);
    term = Expression();
    m.add(stmt, RDF.type, SQLViewVocabulary.WhereClause);
    m.add(stmt, SQLViewVocabulary.term, term);
    {if (true) return stmt;}
    throw new Error("Missing return statement in function");
  }

  final public Resource FromClause() throws ParseException, ModelException {
  Resource stmt = m.unique();
  Resource clause;
  List clauses = new ArrayList();
    addDebugInfo(stmt);
    jj_consume_token(FROM);
    clause = AliasClause();
    clauses.add(clause);
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[25] = jj_gen;
        break label_10;
      }
      jj_consume_token(COMMA);
      clause = AliasClause();
      clauses.add(clause);
    }
    m.add(stmt, RDF.type, SQLViewVocabulary.FromClause);
    m.addOrdered(stmt, SQLViewVocabulary.inFromClause, clauses);
    {if (true) return stmt;}
    throw new Error("Missing return statement in function");
  }

  final public Resource NestedSelectStmt() throws ParseException, ModelException {
  Resource term;
    jj_consume_token(LPAREN);
    term = SelectStmt();
    jj_consume_token(RPAREN);
    {if (true) return term;}
    throw new Error("Missing return statement in function");
  }

  final public Resource AliasClause() throws ParseException, ModelException {
  Resource stmt = m.unique();
  Resource term = null;
  String tableName = null;
  Token aliasName = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
    addDebugInfo(stmt);
      term = NestedSelectStmt();
      break;
    case IDENTIFIER:
      tableName = TableName();
      break;
    default:
      jj_la1[26] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
      jj_consume_token(AS);
      break;
    default:
      jj_la1[27] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      aliasName = jj_consume_token(IDENTIFIER);
      break;
    default:
      jj_la1[28] = jj_gen;
      ;
    }
    m.add(stmt, RDF.type, SQLViewVocabulary.AliasClause);
    if(term != null)
      m.add(stmt, SQLViewVocabulary.term, term);
    else
      m.add(stmt, SQLViewVocabulary.tableRef, tableName);
    if(aliasName != null)
      m.add(stmt, SQLViewVocabulary.aliasName, aliasName.image);
    {if (true) return stmt;}
    throw new Error("Missing return statement in function");
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  final private boolean jj_3R_17() {
    if (jj_scan_token(SELECT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_31()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_32()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_33()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_34()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_18() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_67() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_29() {
    if (jj_scan_token(PLUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_26() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_29()) {
    jj_scanpos = xsp;
    if (jj_3R_30()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_23()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_66() {
    if (jj_scan_token(WHEN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(THEN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_60() {
    if (jj_scan_token(CASE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    if (jj_3R_66()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_66()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    xsp = jj_scanpos;
    if (jj_3R_67()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(END)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_16() {
    if (jj_3R_23()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_26()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_70() {
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EQUALS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_51() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_50() {
    if (jj_scan_token(AS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_49() {
    if (jj_3R_56()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_3R_14()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_20() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_55() {
    if (jj_3R_60()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_11() {
    if (jj_3R_16()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_15() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_20()) {
    jj_scanpos = xsp;
    if (jj_3R_21()) {
    jj_scanpos = xsp;
    if (jj_3R_22()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_54() {
    if (jj_3R_15()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_48() {
    if (jj_3R_12()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_53() {
    if (jj_3R_59()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_3R_13()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_44() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_48()) {
    jj_scanpos = xsp;
    if (jj_3R_49()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_50()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_51()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_3R_12()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_69() {
    if (jj_3R_70()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_47() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_2()) {
    jj_scanpos = xsp;
    if (jj_3_3()) {
    jj_scanpos = xsp;
    if (jj_3R_53()) {
    jj_scanpos = xsp;
    if (jj_3R_54()) {
    jj_scanpos = xsp;
    if (jj_3R_55()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_68() {
    if (jj_3R_14()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_40() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_64() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_68()) {
    jj_scanpos = xsp;
    if (jj_3R_69()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_32() {
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_40()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_43() {
    if (jj_3R_47()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_12() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_17()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_65() {
    if (jj_3R_32()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_36() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_1()) {
    jj_scanpos = xsp;
    if (jj_3R_43()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_13() {
    if (jj_3R_18()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_65()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_63() {
    if (jj_scan_token(NOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_61() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_63()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_45() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_44()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_35() {
    if (jj_scan_token(MINUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_27() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_35()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_41() {
    if (jj_scan_token(FROM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_44()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_45()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_62() {
    if (jj_scan_token(AND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_61()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_57() {
    if (jj_3R_61()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_62()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_37() {
    if (jj_scan_token(MODULO)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_27()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_22() {
    if (jj_scan_token(NULL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_59() {
    if (jj_3R_18()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_25() {
    if (jj_3R_27()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_37()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_39() {
    if (jj_scan_token(SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_42() {
    if (jj_scan_token(WHERE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_46()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_58() {
    if (jj_scan_token(OR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_52() {
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_58()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_38() {
    if (jj_scan_token(TIMES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_28() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_38()) {
    jj_scanpos = xsp;
    if (jj_3R_39()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_25()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_19() {
    if (jj_3R_12()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_34() {
    if (jj_3R_42()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_24() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_15()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_46() {
    if (jj_3R_52()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_31() {
    if (jj_scan_token(DISTINCT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_23() {
    if (jj_3R_25()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_28()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_33() {
    if (jj_3R_41()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_15()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_24()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_56() {
    if (jj_3R_18()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_30() {
    if (jj_scan_token(MINUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_14() {
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_5()) {
    jj_scanpos = xsp;
    if (jj_3R_19()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_21() {
    if (jj_scan_token(FLOATING_POINT_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public SQLViewTokenManager token_source;
  ASCII_UCodeESC_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[29];
  final private int[] jj_la1_0 = {0x1200,0x1200,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xd8400000,0xd8400000,0x800000,0x2000000,0x80000,0x40000,0x200000,0xd8400000,0x0,0x0,0xd8400000,0x58000000,0x2000,0x4000,0x8000,0x0,0x80000000,0x800,0x80000000,};
  final private int[] jj_la1_1 = {0x0,0x0,0x200,0x200,0x3000,0x3000,0x18000,0x18000,0x4000,0x1000,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x1004,0x200,0x4,0x1004,0x0,0x0,0x0,0x0,0x200,0x4,0x0,0x0,};
  final private JJCalls[] jj_2_rtns = new JJCalls[5];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public SQLView(java.io.InputStream stream) {
    jj_input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source = new SQLViewTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 29; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 29; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public SQLView(java.io.Reader stream) {
    jj_input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source = new SQLViewTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 29; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 29; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public SQLView(SQLViewTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 29; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(SQLViewTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 29; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[49];
    for (int i = 0; i < 49; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 29; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 49; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 5; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
