package com.interdataworking.gateway.xml;

import java.util.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.implementation.model.*;

public class XSDVocabulary {

  public static final String _Namespace = "http://www.w3.org/2001/XMLSchema";
  static final String NN = null;

  public static Resource complexType, simpleType, annotation, documentation, sequence, element;
  public static Resource attribute, type, minOccurs, maxOccurs, ref, base, name, schema, default_, use, restriction;

  public static Set ALL;

  static {
    try {
      setNodeFactory(new org.w3c.rdf.util.RDFFactoryImpl().getNodeFactory());
    } catch (ModelException ex) { ex.printStackTrace(System.err); }
  }

  private static Resource createResource(NodeFactory f, String ns, String suffix) throws ModelException {
    Resource r = f.createResource(ns, suffix);
    ALL.add(r);
    return r;
  }

  public static void setNodeFactory(NodeFactory f) throws ModelException {
    
    ALL = new HashSet();

    simpleType = createResource(f, _Namespace, "simpleType");
    complexType = createResource(f, _Namespace, "complexType");
    annotation = createResource(f, _Namespace, "annotation");
    restriction = createResource(f, _Namespace, "restriction");
    documentation = createResource(f, _Namespace, "documentation");
    sequence = createResource(f, _Namespace, "sequence");
    element = createResource(f, _Namespace, "element");
    attribute = createResource(f, _Namespace, "attribute");
    type = createResource(f, _Namespace, "type");
    schema = createResource(f, _Namespace, "schema");

    // w/o namespace
    type = createResource(f, NN, "type");
    base = createResource(f, NN, "base");
    name = createResource(f, NN, "name");
    ref = createResource(f, NN, "ref");
    default_ = createResource(f, NN, "default");
    use = createResource(f, NN, "use");
    minOccurs = createResource(f, NN, "minOccurs");
    maxOccurs = createResource(f, NN, "maxOccurs");
  }
}
