package com.interdataworking.mm.alg;

import java.util.*;
import org.w3c.rdf.model.*;
import com.interdataworking.*;
import com.interdataworking.mm.*;
import com.interdataworking.mm.interpreter.*;

public class All extends Range {

  public All() {
    super();
    addRange = true;
    addDomain = true;
  }

  public Resource getSearchPredicate(MapVocabulary M) {

    return null; // find all
  }

  public List execute(List input) throws ModelException {

    Model m = (Model)input.get(0);

    LanguageCallback cb = null;
    cb = ((ParameterList)input).getExecutionContext().getLanguageCallback(m);

    if(cb == null) {
      System.err.println("[All] No callback found, returning all nodes!");
      return super.execute(input);

    } else {

      Set all = cb.all(m);
      if(all == null) {
	System.err.println("[All] Callback does not implement, returning all nodes!");
	return super.execute(input);
      }

      ArrayList l = new ArrayList();
      l.add(MapVocabulary.asModel(m.create(), all));
      return l;
    }
  }
}
