package com.interdataworking.mm.alg;

import com.interdataworking.*;
import org.w3c.rdf.model.*;
import java.util.*;

/** all objects from m1 are preserved */

public class FinalizeMap implements UntypedGateway {

  static final int MIN_CHOICE_ITEMS = 5;

  public static List getFinalizeMap(List arr) {

    //    return MapPair.prune(arr, MIN_CHOICE_ITEMS);

    Object[] a = arr.toArray();
    MapPair.sort(a);
    arr = Arrays.asList(a);

    //    List result = new ArrayList();

    for(int i=0; i<arr.size(); i++) {

      MapPair p = (MapPair)arr.get(i);
      p.sim = 1.0 / arr.size() * (arr.size() - i);
    }
    return arr;
  }

  public List execute(List input) throws ModelException {

    Model src = (Model)input.get(0);

    List l1 = MapPair.toMapPairs(src);
    List best = getFinalizeMap(l1);

    ArrayList l = new ArrayList();
    Model dest = MapPair.asModel(src.create(), best.toArray());
    l.add(dest);
    return l;
  }
  

  public int getMinInputLen() { return 1; }

  public int getMaxInputLen() { return 1; }

  public int getMinOutputLen() { return 1; }

  public int getMaxOutputLen() { return 1; }

}
