package com.interdataworking.mm.alg;

import com.interdataworking.*;
import org.w3c.rdf.model.*;
import java.util.*;

/** all objects from m1 are preserved */

public class MergeMap implements UntypedGateway {

  public static List getMergeMap(List src, Collection dest) {

    // take src and "override" it with dest

    HashMap set = new HashMap(); // pairs that are done

    for(int i=0; i<src.size(); i++) {

      MapPair p = (MapPair)src.get(i);
      set.put(p, p);
    }

    Iterator it = dest.iterator();
    while(it.hasNext()) {

      MapPair p = (MapPair)it.next();
      MapPair old = (MapPair)set.get(p);

      if(old != null)
	old.sim = p.sim; // override similarity
      else
	src.add(p); // was missing
    }

    return src;
  }

  public List execute(List input) throws ModelException {

    Model src = (Model)input.get(0);
    Model dest = (Model)input.get(1);

    List l1 = MapPair.toMapPairs(src);
    List l2 = MapPair.toMapPairs(dest);
    List best = getMergeMap(l1, l2);

    ArrayList l = new ArrayList();
    Model result = MapPair.asModel(src.create(), best.toArray());
    l.add(result);
    return l;
  }
  

  public int getMinInputLen() { return 2; }

  public int getMaxInputLen() { return 2; }

  public int getMinOutputLen() { return 1; }

  public int getMaxOutputLen() { return 1; }

}
