package com.interdataworking.mm.alg;

import com.interdataworking.*;
import org.w3c.rdf.model.*;
import java.util.*;

/** all objects from m1 are preserved */

public class OneSimilarity implements UntypedGateway {

  public static List oneSimilarity(List arr) {

    List result = new ArrayList();

    for(int i=0; i<arr.size(); i++) {

      MapPair p = (MapPair)arr.get(i);
      p = p.duplicate();
      p.sim = 1.0;
      result.add(p);
    }
    return result;
  }

  public List execute(List input) throws ModelException {

    Model src = (Model)input.get(0);

    List l1 = MapPair.toMapPairs(src);
    List best = oneSimilarity(l1);

    ArrayList l = new ArrayList();
    Model dest = MapPair.asModel(src.create(), best.toArray());
    l.add(dest);
    return l;
  }
  

  public int getMinInputLen() { return 1; }

  public int getMaxInputLen() { return 1; }

  public int getMinOutputLen() { return 1; }

  public int getMaxOutputLen() { return 1; }

}
