package com.interdataworking.mm.alg;

import com.interdataworking.*;
import org.w3c.rdf.model.*;
import java.util.*;
import java.text.DecimalFormat;

public class PrecisionRecallThreshold implements UntypedGateway {

  static final DecimalFormat nf = new DecimalFormat("##.00");

  //  static final double MAX_TH = 0.3;
  static final double MAX_TH = 1.00001;


  public static void getPrecisionRecallThreshold(List actual, List correct, double increment) {

    Set intended = new HashSet();
    intended.addAll(correct);
    getPrecisionRecallThreshold(actual, intended, increment);
  }

  public static void getPrecisionRecallThreshold(List actual, Set intended, double increment) {

    // calculate number of correct matches that have been delivered

    Object[] a = actual.toArray();

    System.out.println("Threshold raw: " + PrecisionRecall.getPrecisionRecall(actual, intended));

    for(double threshold = 0.0; threshold <= MAX_TH; threshold += increment) {

      List computed = new ArrayList();
      ThresholdMatch matcher = new ThresholdMatch();
      matcher.getThresholdMatch(a, computed, threshold);

      System.out.println("Threshold: " + nf.format(1-threshold) + ", " +
			 PrecisionRecall.getPrecisionRecall(computed, intended) + ", " +
			 MapStatistics.getMapStatistics(computed));
    }
  }

  public List execute(List input) throws ModelException {

    Model actual = (Model)input.get(0);
    List l1 = MapPair.toMapPairs(actual);

    Model correct = (Model)input.get(1);
    List l2 = MapPair.toMapPairs(correct);

    double increment = 0.1;

    if(input.size() == 3)
      increment = Double.parseDouble((String)input.get(2));

    getPrecisionRecallThreshold(l1, l2, increment);

    return new ArrayList();
  }
  

  public int getMinInputLen() { return 2; }

  public int getMaxInputLen() { return 3; }

  public int getMinOutputLen() { return 0; }

  public int getMaxOutputLen() { return 0; }

}
