package com.interdataworking.mm.alg;

import com.interdataworking.mm.NodeFilter;
import org.w3c.rdf.model.*;
import com.interdataworking.gateway.sqlddl.*;
import java.util.*;
import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;
import org.w3c.rdf.vocabulary.rdf_schema_19990303.RDFS;

// ignore everything apart of Tables, Columns, Keys and ReferentialConstraints

public class RDFSNodeFilter implements NodeFilter {

  Set valid = new HashSet();

  public RDFSNodeFilter(Model m) throws ModelException {

    Set validTypes = new HashSet();
    validTypes.add(RDFS.Class);
    validTypes.add(RDF.Property);

    // collect valid nodes
    Enumeration en = m.elements();
    while(en.hasMoreElements()) {

      Statement st = (Statement)en.nextElement();
      if(RDF.type.equals(st.predicate())) {

	Resource type = (Resource)st.object();
	if(validTypes.contains(type))
	  valid.add(st.subject());
      }
    }
  }

  public boolean filterOutNode(RDFNode n) {

    return !valid.contains(n);
  }
  
}
