package com.interdataworking.mm.alg;

import com.interdataworking.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import java.util.*;

public class ReplaceIDs implements UntypedGateway {

  public List execute(List input) throws ModelException {

    Model src = (Model)input.get(0);
    Model dest = src.create();
    Model mapM = (Model)input.get(1);

    Map map = MapPair.toJavaMapDropSimilarity(MapPair.toMapPairs(mapM));

    RDFUtil.replaceResources(src, dest, map);

    List l = new ArrayList();
    l.add(dest);
    return l;
  }

  public int getMinInputLen() { return 2; } // source, dest, map

  public int getMaxInputLen() { return 2; }

  public int getMinOutputLen() { return 1; }

  public int getMaxOutputLen() { return 1; }

}
