package com.interdataworking.mm.alg;

import com.interdataworking.*;
import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import java.util.*;
import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;
import com.interdataworking.mm.MapVocabulary;

public class Reverse implements UntypedGateway {

  // of MapPairs
  public static List reverse(List list) {

    List result = new ArrayList();

    for(int i = 0; i < list.size(); i++) {

      MapPair p = (MapPair)list.get(i);
      MapPair n = p.duplicate();
      n.inverse = !p.inverse;
      result.add(n);
    }

    return result;
  }

  public static Model reverse(Model map) throws ModelException {

    return MapPair.asModel(map, reverse(MapPair.toMapPairs(map)));
  }

  public List execute(List input) throws ModelException {

    Model src = (Model)input.get(0);
    Model dest = reverse(src);

    List l = new ArrayList();
    l.add(dest);
    return l;
  }
  

  public int getMinInputLen() { return 1; }

  public int getMaxInputLen() { return 1; }

  public int getMinOutputLen() { return 1; }

  public int getMaxOutputLen() { return 1; }

}
