package com.interdataworking.mm.gui;

import java.awt.*;

public class GUIUtil {

  /**
   * last two parameters are arrow height and width
   */
  public static void drawArrow(Graphics graphics, int fromX, int fromY, int toX, int toY, int h, int w, Color fillColor, Color lineColor, boolean closed) {

    // dx, dy to arrow top
    int dx = toX - fromX;
    int dy = toY - fromY;

    double lratio = h / Math.sqrt(dx*dx + dy*dy);

    dx = (int)(dx * lratio);
    dy = (int)(dy * lratio);

    // bottom middle of arrow
    int x = toX - dx;
    int y = toY - dy;

    // left corner
    int leftX = x + (dy * h / w / 2);
    int leftY = y - (dx * h / w / 2);

    // right corner
    int rightX = x - (dy * h / w / 2);
    int rightY = y + (dx * h / w / 2);

//     int[] xc = {toX, rightX, leftX, toX};
//     int[] yc = {toY, rightY, leftY, toY};

    int[] xc = {leftX, toX, rightX, leftX};
    int[] yc = {leftY, toY, rightY, leftY};

    if(closed) {
      if(fillColor != null)
	graphics.setColor(fillColor);
      graphics.fillPolygon(xc, yc, 4);

      if(lineColor != null)
	graphics.setColor(lineColor);
      graphics.drawPolygon(xc, yc, 4);

    } else // open
      graphics.drawPolyline(xc, yc, 3);
  }
}
