/* Generated By:JavaCC: Do not edit this line. ScriptParser.java */
package com.interdataworking.mm.interpreter.parser;

import java.util.*;
import java.io.*;
//import java.sql.*;

import org.w3c.rdf.model.*;
import org.w3c.rdf.syntax.*;
import org.w3c.rdf.util.*;
//import org.w3c.rdf.implementation.query.*;
//import org.w3c.rdf.implementation.model.*;
import org.xml.sax.InputSource;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
//import org.w3c.rdf.implementation.syntax.sirpac.SiRPAC; // need to set default parsing params
import com.interdataworking.*;
import com.interdataworking.mm.*;
import com.interdataworking.mm.interpreter.*;
import edu.stanford.db.rdf.model.i.Registry;
import org.w3c.rdf.vocabulary.rdf_syntax_19990222.RDF;

public class ScriptParser implements ScriptParserConstants {

  // make sure we can use MatchSQL
  static {
     Registry.setDefaultRegistry(new Registry(true));
  }

//  static RDFFactory rf = new RDFFactoryImpl();
//  static NodeFactory factory = rf.getNodeFactory(); // Registry.getDefaultRegistry();

  ExecutionContext ctx;
  Resource start; // starting node of the script
  String fileName; // name of file being parsed (if any)

  void log(String s) {

    Token t = token;
    if(s.endsWith("\n"))
      s = s.substring(0, s.length()-1) + " at (" + t.beginLine + "," + t.beginColumn + ")\n";
    ctx.log(s);
  }

  void addDebugInfo(Resource r) throws ModelException {

//    String str = "(row " + token.beginLine + ", column " + token.beginColumn + ")";

    String str = fileName + " (" + token.beginLine + "," + token.beginColumn + ")";
    ctx.add(r, Script.debugInfo, ctx.createLiteral(str));
  }

  public static Resource parseIt(String fileName, ExecutionContext ctx) throws Exception {

    File fn = ctx.getRelative(ctx.currentDir(), fileName);
    fileName = fn.getCanonicalPath();

    Resource script = ctx.getProcessed(fileName);

    if(script == null) {

      ctx.pushd(fn);
      ScriptParser p = new ScriptParser(new FileReader(fn));
      p.ctx = ctx;
      p.fileName = fn.getName();
      p.log("Processing script " + fileName + "\n");
      script = p.start = ctx.createUniqueResource();
//      p.log("Created unique resource " + script);

      ctx.addProcessed(fileName, p.start);
      p.Input();
      ctx.popd();
      p.log("Script " + fileName + " done.\n");
    }

    return script;
  }

  void warnIfDefined(String operator) {

    if(ctx.isDefined(operator))
      log("Warning: redefining operator " + operator + "\n");
  }

  Resource createFctTerm(Resource t, String opName, List inputList) throws ModelException {

//    Resource t = ctx.createUniqueResource();
    ctx.add(t, RDF.type, Script.FunctionalTerm);
    ctx.add(t, Script.operatorName, opName);
    ctx.addOrdered(t, Script.term, inputList);
    return t;
  }


  public static void main(String args[]) throws Exception {

    ExecutionContext ctx = new ExecutionContext();
    Resource start = null;

    RDFFactory rf = new RDFFactoryImpl();

    try {

      ctx.setScriptModel(rf.createModel());
      start = ScriptParser.parseIt(args[0], ctx);

    } catch (SAXException ex) {
      throw ex.getException() != null ? ex.getException() : ex;
    }

    RDFUtil.printStatements(ctx.getScriptModel(), System.out);
    RDFUtil.dumpModel(ctx.getScriptModel(), System.out, rf.createSerializer());
  }

  final public void Input() throws ParseException, Exception {
  ArrayList list = new ArrayList();
  Resource stmt;
   ctx.add(this.start, RDF.type, Script.Script);
   addDebugInfo(this.start);
    label_1:
    while (true) {
    stmt = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ALIAS:
        AliasStmt();
        break;
      case DBCONFIG:
        DBConfig();
        break;
      case REGISTERLANGUAGE:
        RegisterLanguageStmt();
        break;
      case READ:
      case WRITE:
      case DBREAD:
      case DBWRITE:
      case POPUP:
      case RETURN:
      case IF:
      case DO:
      case WHILE:
      case STRING_LITERAL:
      case IDENTIFIER:
      case LPAREN:
        stmt = BlockStmt();
        break;
      case INCLUDE:
        stmt = IncludeStmt();
        break;
      case OPERATOR:
        stmt = OperatorDef();
        break;
      default:
        jj_la1[0] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      if(stmt != null)
        list.add(stmt);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ALIAS:
      case INCLUDE:
      case READ:
      case WRITE:
      case DBCONFIG:
      case DBREAD:
      case DBWRITE:
      case POPUP:
      case REGISTERLANGUAGE:
      case RETURN:
      case OPERATOR:
      case IF:
      case DO:
      case WHILE:
      case STRING_LITERAL:
      case IDENTIFIER:
      case LPAREN:
        ;
        break;
      default:
        jj_la1[1] = jj_gen;
        break label_1;
      }
    }
//   System.err.println("Script " + start + " + with " + list);
   ctx.addOrdered(this.start, Script.expression, list);
    jj_consume_token(0);
  }

  final public Resource BlockStmt() throws ParseException, Exception {
  Resource stmt;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case READ:
      stmt = ReadStmt();
      break;
    case WRITE:
      stmt = WriteStmt();
      break;
    case STRING_LITERAL:
    case IDENTIFIER:
    case LPAREN:
      stmt = AssignStmt();
      break;
    case RETURN:
      stmt = ReturnStmt();
      break;
    case DBREAD:
      stmt = DBRead();
      break;
    case DBWRITE:
      stmt = DBWrite();
      break;
    case POPUP:
      stmt = PopupStmt();
      break;
    case IF:
      stmt = IfStatement();
      break;
    case DO:
      stmt = DoStatement();
      break;
    case WHILE:
      stmt = WhileStatement();
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return stmt;}
    throw new Error("Missing return statement in function");
  }

  final public String OperatorName() throws ParseException {
  Token t;
  String s;
    t = jj_consume_token(IDENTIFIER);
    s = t.image;
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        ;
        break;
      default:
        jj_la1[3] = jj_gen;
        break label_2;
      }
      jj_consume_token(DOT);
      t = jj_consume_token(IDENTIFIER);
    s += "." + t.image;
    }
    {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

  final public ArrayList SingleIdentifierOrList() throws ParseException {
 Token t;
 ArrayList out = new ArrayList();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      t = jj_consume_token(IDENTIFIER);
    out.add(t.image);
      break;
    case LPAREN:
      out = IdentifierList();
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
   {if (true) return out;}
    throw new Error("Missing return statement in function");
  }

  final public ArrayList IdentifierList() throws ParseException {
  ArrayList list = new ArrayList();
  Token t;
    jj_consume_token(LPAREN);
    t = jj_consume_token(IDENTIFIER);
    list.add(t.image);
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_3;
      }
      jj_consume_token(COMMA);
      t = jj_consume_token(IDENTIFIER);
    list.add(t.image);
    }
    jj_consume_token(RPAREN);
    {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  final public ArrayList SingleTermOrList() throws ParseException, ModelException {
 Resource term;
 ArrayList out = new ArrayList();
    if (jj_2_1(2147483647)) {
      term = Term();
    out.add(term);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        out = TermList();
        break;
      default:
        jj_la1[6] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
   {if (true) return out;}
    throw new Error("Missing return statement in function");
  }

  final public ArrayList TermList() throws ParseException, ModelException {
  ArrayList list = new ArrayList();
  Resource ex;
    jj_consume_token(LPAREN);
    ex = Term();
    list.add(ex);
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[7] = jj_gen;
        break label_4;
      }
      jj_consume_token(COMMA);
      ex = Term();
    list.add(ex);
    }
    jj_consume_token(RPAREN);
    {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  final public List StatementList() throws ParseException, Exception {
  List list = new ArrayList();
  Resource stmt = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      jj_consume_token(LBRACE);
      label_5:
      while (true) {
        stmt = BlockStmt();
                          list.add(stmt);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case READ:
        case WRITE:
        case DBREAD:
        case DBWRITE:
        case POPUP:
        case RETURN:
        case IF:
        case DO:
        case WHILE:
        case STRING_LITERAL:
        case IDENTIFIER:
        case LPAREN:
          ;
          break;
        default:
          jj_la1[8] = jj_gen;
          break label_5;
        }
      }
      jj_consume_token(RBRACE);
      break;
    case READ:
    case WRITE:
    case DBREAD:
    case DBWRITE:
    case POPUP:
    case RETURN:
    case IF:
    case DO:
    case WHILE:
    case STRING_LITERAL:
    case IDENTIFIER:
    case LPAREN:
      stmt = BlockStmt();
                       list.add(stmt);
      break;
    default:
      jj_la1[9] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
   {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  final public Resource OperatorDef() throws ParseException, Exception {
  List out = new ArrayList(), list = null;
  Token opname;
  Resource stmt;
    jj_consume_token(OPERATOR);
    Resource op = ctx.createUniqueResource();
    addDebugInfo(op);
    opname = jj_consume_token(IDENTIFIER);
    warnIfDefined(opname.image);
    out = IdentifierList();
    list = StatementList();
    ctx.add(op, RDF.type, Script.Operator);
    ctx.add(op, Script.operatorName, opname.image);
    ctx.addOrdered(op, Script.variable, out);
    ctx.addOrdered(op, Script.expression, list);
    ctx.addDefinition(opname.image, op);
    {if (true) return op;}
    throw new Error("Missing return statement in function");
  }

  final public Resource IfStatement() throws ParseException, Exception {
  List out = new ArrayList(), thenList = null, elseList = null;
  Token opname;
  Resource cond;
    Resource op = ctx.createUniqueResource();
    addDebugInfo(op);
    jj_consume_token(IF);
    jj_consume_token(LPAREN);
    cond = FunctionalTerm();
    jj_consume_token(RPAREN);
    thenList = StatementList();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELSE:
      jj_consume_token(ELSE);
      elseList = StatementList();
      break;
    default:
      jj_la1[10] = jj_gen;
      ;
    }
    ctx.add(op, RDF.type, Script.IfStatement);
    ctx.add(op, Script.ifExpression, cond);
    ctx.addOrdered(op, Script.thenStatement, thenList);
    if(elseList != null)
      ctx.addOrdered(op, Script.elseStatement, elseList);
    {if (true) return op;}
    throw new Error("Missing return statement in function");
  }

  final public Resource DoStatement() throws ParseException, Exception {
  List list;
  Token opname;
  Resource cond;
    Resource op = ctx.createUniqueResource();
    addDebugInfo(op);
    jj_consume_token(DO);
    list = StatementList();
    jj_consume_token(WHILE);
    jj_consume_token(LPAREN);
    cond = Term();
    jj_consume_token(RPAREN);
    jj_consume_token(SEMICOLON);
    ctx.add(op, RDF.type, Script.DoStatement);
    ctx.add(op, Script.ifExpression, cond);
    ctx.addOrdered(op, Script.expression, list);
    {if (true) return op;}
    throw new Error("Missing return statement in function");
  }

  final public Resource WhileStatement() throws ParseException, Exception {
  List list;
  Token opname;
  Resource cond;
    Resource op = ctx.createUniqueResource();
    addDebugInfo(op);
    jj_consume_token(WHILE);
    jj_consume_token(LPAREN);
    cond = Term();
    jj_consume_token(RPAREN);
    list = StatementList();
    ctx.add(op, RDF.type, Script.WhileStatement);
    ctx.add(op, Script.ifExpression, cond);
    ctx.addOrdered(op, Script.expression, list);
    {if (true) return op;}
    throw new Error("Missing return statement in function");
  }

  final public void EmptyStatement() throws ParseException {
    jj_consume_token(SEMICOLON);
  }

  final public Resource ReturnStmt() throws ParseException, ModelException {
  List out = null;
      Resource a = ctx.createUniqueResource();
      addDebugInfo(a);
    jj_consume_token(RETURN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING_LITERAL:
    case IDENTIFIER:
    case LPAREN:
      out = SingleTermOrList();
      break;
    default:
      jj_la1[11] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
      ctx.add(a, RDF.type, Script.ReturnExpression);
      if(out != null)
        ctx.addOrdered(a, Script.term, out);
      {if (true) return a;}
    throw new Error("Missing return statement in function");
  }

  final public Resource AssignStmt() throws ParseException, ModelException {
  List out = new ArrayList(); // of variables
  Resource in; // term
  String clsname;
      Resource a = ctx.createUniqueResource();
      addDebugInfo(a);
    if (jj_2_2(2147483647)) {
      out = SingleIdentifierOrList();
      jj_consume_token(EQUALS);
    } else {
      ;
    }
    in = Term();
    jj_consume_token(SEMICOLON);
      ctx.add(a, RDF.type, Script.Assignment);
      ctx.addOrdered(a, Script.variable, out);
      ctx.add(a, Script.term, in);
      {if (true) return a;}
    throw new Error("Missing return statement in function");
  }

// returns Term definition
  final public Resource Term() throws ParseException, ModelException {
  Resource t;
    t = SumTerm();
   {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

  final public Resource ParenTerm() throws ParseException, ModelException {
  Resource term = null;
    if (jj_2_3(2)) {
      jj_consume_token(LPAREN);
      term = SumTerm();
      jj_consume_token(RPAREN);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STRING_LITERAL:
      case IDENTIFIER:
      case LPAREN:
        term = SumTerm();
        break;
      default:
        jj_la1[12] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
   {if (true) return term;}
    throw new Error("Missing return statement in function");
  }

  final public Resource SumTerm() throws ParseException, ModelException {
  Resource term1 = null;
  Resource term2 = null;
  Token x = null;
    term1 = TimesTerm();
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MINUS:
      case PLUS:
        ;
        break;
      default:
        jj_la1[13] = jj_gen;
        break label_6;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        x = jj_consume_token(PLUS);
        break;
      case MINUS:
        x = jj_consume_token(MINUS);
        break;
      default:
        jj_la1[14] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      Resource stmt = ctx.createUniqueResource(); addDebugInfo(stmt);
      term2 = TimesTerm();
     List l = new ArrayList();
     l.add(term1);
     l.add(term2);
     String opName = null;
     switch(x.kind) {
       case PLUS: opName = "Union"; break;
       case MINUS: opName = "Subtract"; break;
     }
     term1 = createFctTerm(stmt, opName, l);
    }
    {if (true) return term1;}
    throw new Error("Missing return statement in function");
  }

  final public Resource TimesTerm() throws ParseException, ModelException {
  Resource term1 = null;
  Resource term2 = null;
    term1 = FunctionalTerm();
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TIMES:
        ;
        break;
      default:
        jj_la1[15] = jj_gen;
        break label_7;
      }
      jj_consume_token(TIMES);
      Resource stmt = ctx.createUniqueResource(); addDebugInfo(stmt);
      term2 = FunctionalTerm();
     List l = new ArrayList();
     l.add(term1);
     l.add(term2);
     term1 = createFctTerm(stmt, "Compose", l);
    }
    {if (true) return term1;}
    throw new Error("Missing return statement in function");
  }

  final public Resource FunctionalTerm() throws ParseException, ModelException {
  Resource term = null;
    if (jj_2_4(2)) {
      jj_consume_token(LPAREN);
      term = Term();
      jj_consume_token(RPAREN);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STRING_LITERAL:
      case IDENTIFIER:
        term = ElementaryTerm();
        break;
      default:
        jj_la1[16] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
   {if (true) return term;}
    throw new Error("Missing return statement in function");
  }

  final public Resource ElementaryTerm() throws ParseException, ModelException {
  List inputList;
  Token var;
  String clsname;
  String s;
    Resource t = ctx.createUniqueResource();
    addDebugInfo(t);
    if (jj_2_5(2147483647)) {
      clsname = OperatorName();
      inputList = TermList();
    ctx.add(t, RDF.type, Script.FunctionalTerm);
    ctx.add(t, Script.operatorName, clsname);
    ctx.addOrdered(t, Script.term, inputList);
    {if (true) return t;}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        var = jj_consume_token(IDENTIFIER);
    ctx.add(t, RDF.type, Script.Variable);
    ctx.add(t, Script.variableName, var.image);
    {if (true) return t;}
        break;
      case STRING_LITERAL:
        s = quotedStr();
    ctx.add(t, RDF.type, Script.Constant);
    ctx.add(t, Script.constantValue, s);
    {if (true) return t;}
        break;
      default:
        jj_la1[17] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

  final public Resource IncludeStmt() throws ParseException, Exception {
  String s;
  Resource r;
    jj_consume_token(INCLUDE);
    s = quotedStr();
    jj_consume_token(SEMICOLON);
    ctx.incDepth();
    r = parseIt(s, ctx);
    ctx.decDepth();
    {if (true) return r;}
    throw new Error("Missing return statement in function");
  }

  final public Resource AliasStmt() throws ParseException, ModelException {
  Token name;
  String cls;
    jj_consume_token(ALIAS);
    name = jj_consume_token(IDENTIFIER);
    cls = OperatorName();
    jj_consume_token(SEMICOLON);
    warnIfDefined(name.image);
    Resource t = ctx.createUniqueResource();
    addDebugInfo(t);
    ctx.add(t, RDF.type, Script.Operator);
    ctx.add(t, Script.javaClassName, cls);
    ctx.add(t, Script.operatorName, name.image);
    ctx.addDefinition(name.image, t);
    {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

  final public String quotedStr() throws ParseException {
  Token t;
    t = jj_consume_token(STRING_LITERAL);
    {if (true) return t.image.substring(1, t.image.length()-1);}
    throw new Error("Missing return statement in function");
  }

  final public Resource ReadStmt() throws ParseException, SAXException, ModelException, FileNotFoundException, IOException {
  Token var;
  String parser;
  Resource fileName = null;
    jj_consume_token(READ);
    Resource t = ctx.createUniqueResource();
    addDebugInfo(t);
    jj_consume_token(LPAREN);
    var = jj_consume_token(IDENTIFIER);
    jj_consume_token(COMMA);
    parser = OperatorName();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      fileName = FunctionalTerm();
      break;
    default:
      jj_la1[18] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    jj_consume_token(SEMICOLON);
    ctx.add(t, RDF.type, Script.ReadExpression);
    ctx.add(t, Script.variable, var.image);
    ctx.add(t, Script.aliasName, parser);
    if(fileName == null)
      ctx.add(t, Script.streamName, "System.in");
    else {
      ctx.add(t, Script.streamName, "file");
      ctx.add(t, Script.streamTarget, fileName);
    }
    {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

  final public Resource WriteStmt() throws ParseException, SAXException, ModelException, IOException, SerializationException {
  Resource var;
  String parser;
  Resource fileName = null;
    jj_consume_token(WRITE);
    Resource t = ctx.createUniqueResource();
    addDebugInfo(t);
    jj_consume_token(LPAREN);
    var = Term();
    jj_consume_token(COMMA);
    parser = OperatorName();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      fileName = FunctionalTerm();
      break;
    default:
      jj_la1[19] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    jj_consume_token(SEMICOLON);
    ctx.add(t, RDF.type, Script.WriteExpression);
    ctx.add(t, Script.term, var);
    ctx.add(t, Script.aliasName, parser);
    if(fileName == null)
      ctx.add(t, Script.streamName, "System.out");
    else {
      ctx.add(t, Script.streamName, "file");
      ctx.add(t, Script.streamTarget, fileName);
    }
    {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

  final public Resource PopupStmt() throws ParseException, SAXException, ModelException, IOException, SerializationException {
  Resource var;
  String parser;
  Resource windowTitle = null;
    jj_consume_token(POPUP);
    Resource t = ctx.createUniqueResource();
    addDebugInfo(t);
    jj_consume_token(LPAREN);
    var = Term();
    jj_consume_token(COMMA);
    parser = OperatorName();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      windowTitle = FunctionalTerm();
      break;
    default:
      jj_la1[20] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    jj_consume_token(SEMICOLON);
    ctx.add(t, RDF.type, Script.WriteExpression);
    ctx.add(t, Script.term, var);
    ctx.add(t, Script.aliasName, parser);

    ctx.add(t, Script.streamName, "window");

    if(windowTitle != null)
      ctx.add(t, Script.streamTarget, windowTitle);

    {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

  final public void DBConfig() throws ParseException {
  String dbDriver, dbURI, dbUser, dbPwd = "";
    jj_consume_token(DBCONFIG);
    jj_consume_token(LPAREN);
    dbDriver = quotedStr();
    jj_consume_token(COMMA);
    dbURI = quotedStr();
    jj_consume_token(COMMA);
    dbUser = quotedStr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      dbPwd = quotedStr();
      break;
    default:
      jj_la1[21] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    jj_consume_token(SEMICOLON);
    ctx.configDB(dbDriver, dbURI, dbUser, dbPwd);
    log("Database configuration: driver=" + dbDriver + ", uri=" + dbURI + "\n");
  }

  final public Resource DBRead() throws ParseException, ModelException {
  Token var;
  Resource url;
    jj_consume_token(DBREAD);
    Resource t = ctx.createUniqueResource();
    addDebugInfo(t);
    jj_consume_token(LPAREN);
    var = jj_consume_token(IDENTIFIER);
    jj_consume_token(COMMA);
    url = FunctionalTerm();
    jj_consume_token(RPAREN);
    jj_consume_token(SEMICOLON);
    ctx.add(t, RDF.type, Script.ReadExpression);
    ctx.add(t, Script.variable, var.image);
    ctx.add(t, Script.streamName, "database");
    ctx.add(t, Script.streamTarget, url);
    {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

  final public Resource DBWrite() throws ParseException, ModelException {
  Token var;
  Resource url;
  Resource list;
    jj_consume_token(DBWRITE);
    Resource t = ctx.createUniqueResource();
    addDebugInfo(t);
    jj_consume_token(LPAREN);
    list = Term();
    jj_consume_token(COMMA);
    url = FunctionalTerm();
    jj_consume_token(RPAREN);
    jj_consume_token(SEMICOLON);
    ctx.add(t, RDF.type, Script.WriteExpression);
    ctx.add(t, Script.term, list);
    ctx.add(t, Script.streamName, "database");
    ctx.add(t, Script.streamTarget, url);
    {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

  final public void RegisterLanguageStmt() throws ParseException, ModelException {
  String callback;
    jj_consume_token(REGISTERLANGUAGE);
    jj_consume_token(LPAREN);
    callback = OperatorName();
    jj_consume_token(RPAREN);
    jj_consume_token(SEMICOLON);
    ctx.addLanguageCallback(callback);
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  final private boolean jj_3R_11() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_15()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_20() {
    if (jj_scan_token(PLUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_16() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_20()) {
    jj_scanpos = xsp;
    if (jj_3R_21()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_14()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_23() {
    if (jj_3R_24()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_22() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_10() {
    if (jj_3R_14()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_16()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_17() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_22()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_18() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_4()) {
    jj_scanpos = xsp;
    if (jj_3R_23()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_30() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_28() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_27() {
    if (jj_3R_28()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_10()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_13() {
    if (jj_3R_17()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_29() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_30()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_19() {
    if (jj_scan_token(TIMES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_18()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_12() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_26() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_9() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_12()) {
    jj_scanpos = xsp;
    if (jj_3R_13()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_14() {
    if (jj_3R_18()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_19()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_8() {
    if (jj_3R_10()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_25() {
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_29()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_3R_9()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EQUALS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_21() {
    if (jj_scan_token(MINUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_15() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_24() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_25()) {
    jj_scanpos = xsp;
    if (jj_3R_26()) {
    jj_scanpos = xsp;
    if (jj_3R_27()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public ScriptParserTokenManager token_source;
  ASCII_UCodeESC_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[22];
  final private int[] jj_la1_0 = {0x13dffe00,0x13dffe00,0x13d5d800,0x0,0x12000000,0x0,0x10000000,0x0,0x13d5d800,0x53d5d800,0x200000,0x13000000,0x13000000,0x0,0x0,0x0,0x3000000,0x3000000,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_1 = {0x0,0x0,0x0,0x10,0x0,0x8,0x0,0x8,0x0,0x0,0x0,0x0,0x0,0xc0,0xc0,0x100,0x0,0x0,0x8,0x8,0x8,0x8,};
  final private JJCalls[] jj_2_rtns = new JJCalls[5];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public ScriptParser(java.io.InputStream stream) {
    jj_input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source = new ScriptParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 22; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 22; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public ScriptParser(java.io.Reader stream) {
    jj_input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source = new ScriptParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 22; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 22; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public ScriptParser(ScriptParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 22; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(ScriptParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 22; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[41];
    for (int i = 0; i < 41; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 22; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 41; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 5; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
