package edu.stanford.db.rdf.query.orderings;

import edu.stanford.db.rdf.query.*;
import org.w3c.rdf.model.*;
import java.util.*;


/**
 * Establishes an order over a list of SubstitutionComparators.
 * First, compares using the first one, than the second one etc.
 */

public class Chained implements SubstitutionComparator {

  SubstitutionComparator[] c;

  public Chained(SubstitutionComparator[] c) {

    this.c = c;
  }

  public int compare(Map s1, Map s2, Model m) throws ModelException {
    
    for(int i=0; i < c.length; i++) {

      int result = c[i].compare(s1, s2, m);
      if(result != 0)
	return result;
    }
    
    return 0;
  }
}
